import java.rmi.Naming;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import java.io.*;

public class AlarmClient {

	public static void main(String args[]) {
		int answer,aux;
		int ans2[] = new int[8];
		int ans3[] = new int[5];
		String clientResponse;
		BufferedReader bufferRead;
		try {
			AlarmMeth sc = (AlarmMeth) Naming.lookup("rmi://127.0.0.1:1099/AlarmServerImpl"); //looking up for the sever
			while(true) {
				//give the menu to the user
				System.out.println("1 - Highest temperature");
				System.out.println("2 - All the current temperatures");
				System.out.println("3 - Current 5 readings for a given probe");
				System.out.println("4 - Average for a given probe");
				System.out.println("5 - Current reading for a given probe");
				System.out.println("6 - Perform a reset on all probes");
				System.out.println("0 - Exit");
				System.out.print("Select: ");
				bufferRead = new BufferedReader(new InputStreamReader(System.in));
				clientResponse = bufferRead.readLine();
				aux = Integer.parseInt(clientResponse);
				switch(aux) {
					case 1: answer = sc.sayHigh(); //asking for the highest current temp
						System.out.println(answer);
						break;

					case 2: ans2 = sc.sayAll(); //asking for all the current readings
						for(int k=0;k<8;k++){
					        	System.out.print("- Probe " + k + " : " + ans2[k] + " ");
						}
						System.out.println("");
						break;
						
					case 3: System.out.println("Probe? "); //waiting, user should give a specific probe
						clientResponse = bufferRead.readLine();
						aux = Integer.parseInt(clientResponse);
						ans3 = sc.sayFive(aux); //asking for the current five readings of a specific probe
 				                for(int j=0; j<5; j++) {
							System.out.print("- " + ans3[j] + " ");
						}
						System.out.println("");
						break;
						
					case 4: System.out.println("Probe? "); //waiting, user should give a specific probe
						clientResponse = bufferRead.readLine();
						aux = Integer.parseInt(clientResponse);
						answer = sc.sayAvg(aux); //asking for the average
						System.out.println("The avg was: " + answer);
						break;
						
					case 5: System.out.println("Probe? "); //waiting, user should give a specific probe
						clientResponse = bufferRead.readLine();
						aux = Integer.parseInt(clientResponse);
						answer = sc.sayOne(aux); //asking for the current reading of a specific probe
						System.out.println("The current temp for " + aux + " was: " + answer);
						break;

					case 6: sc.doReset(); //asking to the server for doing a reset in the buffer
						break;
						
					case 0: System.exit(-1); //exiting the client interface
						break;

					default: System.out.println("err: wrong option");
						 break;
				}
			}

		} catch (Exception e) {
			System.out.println("Exception" + e);
		}
	}
}	
