import java.rmi.*;

public interface AlarmMeth extends Remote {

	//returns the highest current temp
	public int sayHigh() throws RemoteException;

	//returns all current probes
	public int[] sayAll() throws RemoteException;

	//returns the 5 latest readings for a given probe
	public int[] sayFive(int probe) throws RemoteException;

	//returns the avg for a given probe
	public int sayAvg(int probe) throws RemoteException;

	//returns the current reading of a specific probe
	public int sayOne(int probe) throws RemoteException;

	//performs a reset
	public void doReset() throws RemoteException;
}
