import java.lang.*;
import java.util.Random;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.registry.LocateRegistry;

public class AlarmServerImpl extends UnicastRemoteObject implements AlarmMeth {
	
	static int saveTemp[][] = new int[8][5]; //table for saving all the temp it could be accessed by each thread
	static int x = 0; // it'll the index for my threads

	public AlarmServerImpl() throws RemoteException {
		super();
	}
	
	public synchronized int sayHigh() throws java.rmi.RemoteException {
    		int maximum = saveTemp[0][0];   // start with the first value
        	
		for(int i=0; i<5; i++) {
			for(int k=0; k<8; k++) {
				if (saveTemp[k][i] > maximum) {
					maximum = saveTemp[k][i];   // new maximum
				}
			}
		}
		System.out.println("A client has asked about highest temp.: " + maximum);
	    	return maximum;
	}

	public synchronized int[] sayAll() throws RemoteException {
                int foo[] = new int[8];
		for(int k=0; k<8; k++) {
	        	System.out.print("- Probe " + x + "." + k + " : " + saveTemp[k][x] + " ");
			foo[k] = saveTemp[k][x]; //all the current (x) temperatures will be saved on foo and it'll be returned
                }
		System.out.println("");
		System.out.println("I've given all the current temps to a client.");
		return foo;
	}

	public synchronized int[] sayFive(int probe) throws RemoteException {
		int five[] = new int[5];
		System.out.println("I'm giving the current 5 for " + probe + " probe:");
		for(int j=0; j<5; j++) {
			five[j] = saveTemp[probe][j]; //saving the last 5 readings for the given probe (probe)
			System.out.print("- " + five[j] + " ");
		}
		System.out.println("");
		return five;
	}
	
	public synchronized int sayAvg(int probe) throws RemoteException {
		int avg=0;
		int aux=0;
		System.out.println("Computing the average for " + probe + " probe:");
		for(int l=0; l<5; l++) {
			aux += saveTemp[probe][l]; // the last five temps added
		}
		avg = aux/5; //calculate the avg
		System.out.println(avg);
		return avg;
	}

	public synchronized int sayOne(int probe) throws RemoteException {
		System.out.println("Giving " + saveTemp[probe][x] + " for the " + probe);
		return saveTemp[probe][x]; //just return the current (x) of a specific proge (probe)
	}
	
	public synchronized void doReset() throws RemoteException {
                for(int i=0; i<5; i++) {
                        for(int k=0; k<8; k++) {
                        	saveTemp[k][i] = 0; //writting zero on each position on our temp. table
	                }
	       	}
		System.out.println("Reset done."); //announcing the reset has done
	}

	private static class AlarmServer extends Thread {
		public int threadnum;
		AlarmServer(int n) {
			threadnum = n; //identifying each thread
		}
	
		public void run() {
			Random r = new Random();
			while(true) {
				saveTemp[threadnum][x] = r.nextInt(1000); //getting random values
				x++;
				if(x >= 5) { x = 0; }
				try{Thread.sleep(2000);} catch(Exception e){} //sleeping the threads 2s
			}
		}

	}

        public static void main (String args[]) {
		
		try {
			AlarmServerImpl sw = new AlarmServerImpl();

			Naming.rebind("rmi://127.0.0.1/AlarmServerImpl", sw); //registering the service

			System.out.println("AlarmServerImpl bound in registry"); //announcing the registry
		
		}
		catch (Exception e) {
			System.out.println(" Server err: " + e.getMessage());
		}
		
		//starting all the threads
                new AlarmServer(0).start();
		new AlarmServer(1).start();
		new AlarmServer(2).start();
		new AlarmServer(3).start();
		new AlarmServer(4).start();
		new AlarmServer(5).start();
		new AlarmServer(6).start();
		new AlarmServer(7).start();

	}

}
